/******************************************************************************/
//    File Name     : Model1.java
//                            Java Applet source file
//    Name          : Yoshiyuki Tanaka
//                    (e-Mail : tanaka_y@jaist.ac.jp)
//    Class Name    :     1.Model1()
/******************************************************************************/

/******************************************************************************/
//                                  IMPORT
/******************************************************************************/
import java.awt.*;

/******************************************************************************/
//    Class Name    : Model1
/******************************************************************************/
public class Model1
{
    /***** VALUE DATA *****/
    public    static  Model1Param param = new Model1Param();

    protected         Dimension   dim   = new Dimension(0, 0);
    protected         int         u     = 0;
    protected         int         myu   = 0;

    /***** CONSTRUCTOR *****/
    Model1(int _u, int _myu){ this.u = _u; this.myu = _myu; }

    Model1(int _u){ this(_u, 0) ;}
    Model1()      { this( 0, 0) ;}

    /***** METHOD DATA *****/
    /**************************************************************************/
    //    Method Name   : reset()
    /**************************************************************************/
    protected void  reset(){ this.u = 0; this.myu = 0; }

    /**************************************************************************/
    //    Method Name   : setModel1()
    /**************************************************************************/
    protected void setCell(int _u){ this.u = _u; this.myu = 0; }

    protected void setdim(){
        this.dim.width  = (int)( param.getd() * Math.random() );
        this.dim.height = (int)( param.getd() * Math.random() );
    }

    /**************************************************************************/
    //    Method Name   : step()
    /**************************************************************************/
    protected void step(int v)
    { this.myu = ( v >= param.getm() )?(param.getn() + 1):0; }
    protected void step(){ this.myu = u - 1; }

    /**************************************************************************/
    //    Method Name   : renewalState()
    /**************************************************************************/
    protected void renewalState(int avr){ u = avr; }
    protected void renewalState()       { u = myu; }

    /**************************************************************************/
    //    Method Name   : checkRecovery()
    //    Method Name   : checkExcited()
    /**************************************************************************/
    public boolean checkReceptive(){ return (this.u == 0); }
    public boolean checkRefractry(){ return (2 <= this.myu)&&( this.myu <= param.getn() ); }
    public boolean checkExcited()  { return ( this.u > param.getn() ); }

    /**************************************************************************/
    //    Method Name   : get_myu()
    /**************************************************************************/
    public int       getmyu(){ return this.myu; }
    public int       getu()  { return this.u; }
    public Dimension getdim(){ return this.dim; };

    /**************************************************************************/
    //    Method Name   : getColor()
    /**************************************************************************/
    public Color getColor(){
        int colorlevel = (int)(240 * this.u)/( (param.getn() + 1) );
        return new Color(colorlevel, colorlevel, colorlevel);
    }
}

/**** END_of_file: Model1.java **************************************************/
